part of xwidgetbase;

// import 'package:collection/collection.dart';
// import 'package:flutter/material.dart';
// import 'package:provider/provider.dart';
// import 'package:shared_preferences/shared_preferences.dart';
// import 'package:xtoolspackage/xtoolspackage.dart';
// import 'package:xwidgetsbase/XStylesBase.dart';
// import 'package:xwidgetsbase/xWidgetsBase.dart';
// import 'XAppData_Base.dart';
// import 'XfxMenu.dart';
// import 'XfxArea.dart';

class XMainPage_Base<T> extends StatefulWidget {
  XMainPage_Base(this.appState, {Key? key, this.title}) : super(key: key);
  final String? title;
  late XAppDataBase appState;

  @override
  XMainPage_BaseState<T> createState() => XMainPage_BaseState<T>();
}

class XMainPage_BaseState<T> extends State<XMainPage_Base<T>> with TickerProviderStateMixin {
  final GlobalKey<ScaffoldState> _scaffoldKey = GlobalKey<ScaffoldState>();
  late TabController? tabController;
  bool menuPinned = true;

  @override
  void initState() {
    tabController = getTabController();
    // tabController!.addListener(() {
    //   setState(() {});
    // });
    super.initState();
  }

  TabController getTabController() {
    return TabController(length: widget.appState.li_XAree.length, vsync: this);
  }

  updateTabController() {
//    tabController = TabController(length: widget.li_XAree!.length, vsync: this);
    tabController = TabController(length: widget.appState.li_XAree.length, vsync: this);

    setState(() {
      print(tabController!.index.toString());
      tabController!.index = widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).idx_Area;
      print(tabController!.index.toString());
    });
  }

  @override
  void dispose() {
    tabController!.dispose();
    super.dispose();
  }

  signOut() {
    SharedPreferences.getInstance().then((prefs) {
      prefs.clear();
    });
    Navigator.pushNamed(context, widget.appState.PgName_Login);
  }

  Future<bool> warnLogOff(BuildContext context) async {
    var rval = await showDialog<bool>(
        context: context,
        builder: (c) => AlertDialog(
              title: Text('Attenzione', textAlign: TextAlign.center, style: TextStyle(color: Colors.yellow)),
              content: Text('Sei sicuro di disconnetterti?'),
              actions: [
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.green), onPressed: () => Navigator.pop(c, true), child: Text('Si')),
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.red), onPressed: () => Navigator.pop(c, false), child: Text('No')),
              ],
            ));
    return rval ?? false;
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<T>(builder: (context, appState, _) {
      return _buildPageLayout(context);
    });
  }

  int lastTabIdx = -1;
  checkActive_Area(XMenuItem item) {
    var x = widget.appState.li_XAree.firstWhereOrNull((element) => element.key_Area == item.key);
    if (x != null) {
      widget.appState.area_Active = x;
    } else {
      lastTabIdx++;
      var xclArea = XArea(
        item.key,
        lastTabIdx,
        widget.appState.xApp.getWidget_FormMenuItem(item),
        color_Area: item.color_BTN,
        label_Area: item.label,
        icon_Area: item.icon_BTN,
      );

      widget.appState.li_XAree.add(xclArea);
      widget.appState.area_Active = xclArea;
    }
  }

  getWidget_Area(XMenuItem item) {
    return Container();
  }

  xBuilder_XMenu(Function() tabController, Function() onPressed_PinnedBTN, bool pinned_Value) {
    return XfxMenu(
      widget.appState.xApp.liXMenus, tabController,
      logOut_Visible: false,
      title: "Menu",
      padding: EdgeInsets.all(10),
      title_Style: XStyles.xStyTextForLabel(Colors.white),
      menu_BackGroundColor: Colors.grey[900],
      onPressed_PinnedBTN: () => onPressed_PinnedBTN(),
      pinned_Value: pinned_Value,
      onPressed_MenuItem: (i) => checkActive_Area(i),
      // nameApp: Text(sex.app_Name, style: XStyles.xStyTextForLabel()),
    );
  }

  _buildPageLayout(BuildContext context) {
    return WillPopScope(
        ////////////////
        onWillPop: () => warnLogOff(context),
        /////////////////////
        child: Scaffold(
          backgroundColor: Colors.black,
          key: _scaffoldKey,
          appBar: null,

          /// X AREA CONTAINER
          body: Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              menuPinned.not()
                  ? XBtnbase(
                      label: "M\nE\nN\nU",
                      width: 30,
                      decoration: BoxDecoration(color: Colors.grey[800], border: Border.all(color: Colors.white, width: 2)),
                      height: MediaQuery.of(context).size.height,
                      label_Color: Colors.white,
                      onPressed: () {
                        _scaffoldKey.currentState!.openDrawer();
                      },
                    )
                  : Container(),
              menuPinned
                  ? xBuilder_XMenu(updateTabController, () {
                      _scaffoldKey.currentState!.closeDrawer();
                      setState(() {
                        menuPinned = !menuPinned;
                      });
                    }, menuPinned)
                  : Container(),
              SizedBox(width: 10),
              Expanded(
                  flex: 15,
                  child: (widget.appState.li_XAree.length < 2)
                      ? (widget.appState.li_XAree.isNotEmpty)
                          ? widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).widget_Area ?? Container()
                          : Container()
                      : XfxArea(
                          tabController: tabController,
                          margin_Horizontal: 0,
                          tapOnTab: (idx) {
                            widget.appState.area_Active = widget.appState.li_XAree.firstWhere((element) => element.idx_Area == idx);
                          },
                          tabs_BackGroundColor: Colors.transparent,
                          title_Visible: false,
                          bottomBar_Visible: false,
                          numberOfTabs: widget.appState.li_XAree.length,
                          isScrollableTabs: false,
                          children: widget.appState.li_XAree.map((x) {
                            return x.widget_Area ?? Container();
                          }).toList(),
                          tabs: widget.appState.li_XAree
                              .map((e) => XTabItem(
                                    e.idx_Area,
                                    e.key_Area,
                                    e.label_Area ?? "No Label",
                                    e.icon_Area ?? Icons.warning,
                                    color_backGroundTab: Colors.grey[900],
                                    color_backGroundTab_Activate: e.color_Area,
                                    labelColor_Disabled: e.color_Area,
                                    iconColor_Active: XColors.foregroundDark,
                                    iconColor_Disabled: XColors.foregroundLight,
                                  ))
                              .toList(),
                        )),
            ],
          ),
          ///////////////////// MENU
          drawer: menuPinned.not()
              ? xBuilder_XMenu(updateTabController, () {
                  _scaffoldKey.currentState!.closeDrawer();
                  setState(() {
                    menuPinned = !menuPinned;
                  });
                }, menuPinned)
              : null,
        ));
  }
}
