part of xwidgetbase;

// import 'package:flutter/foundation.dart';
// import 'package:flutter/material.dart';

// import '../XStylesBase.dart';
// import '../xWidgetsBase.dart';

class XfxMenu extends StatelessWidget {
  final String? label;
  final GestureTapCallback? logOut_OnTap;
  final GestureTapCallback? nameApp_OnTap;
  final Widget? nameApp;
  final String? title;
  final EdgeInsetsGeometry? padding;
  final AlignmentGeometry? alignment;
  final bool? logOut_Visible;
  final Color? menu_BackGroundColor;
  final Color? logOut_BackGroundColor;
  final Widget? logOut_Text;
  final Widget? logOut_Icon;
  final TextStyle? title_Style;
  final List<XMenuGroup> menuGroups;
  final double? width_menuItems;
  final double? height_menuItems;
  final bool pinned_Value;
  late Function() tabLink;
  final void Function()? onPressed_PinnedBTN;

  ///Verrà chiamata ogni volta che lo user Tappa l'item del Menu e deve tornare il Widget da mettere nel relativo XTab csomai fosse da aprire
  late void Function(XMenuItem)? onPressed_MenuItem;

  //CLASS NEW
  XfxMenu(
    this.menuGroups,
    this.tabLink, {
    this.nameApp,
    this.pinned_Value = true,
    this.onPressed_PinnedBTN,
    this.nameApp_OnTap,
    this.height_menuItems,
    this.width_menuItems,
    this.logOut_BackGroundColor,
    this.logOut_Text,
    this.logOut_Icon,
    this.logOut_Visible,
    this.alignment,
    this.menu_BackGroundColor,
    this.label,
    this.title_Style,
    this.title,
    this.padding,
    this.logOut_OnTap,
    this.onPressed_MenuItem,
  });

  Widget xBuilder_XMenu(XMenuGroup xclMenu) {
    return Column(
      children: xclMenu.items.map((xclMenuItem) {
        return XBtnbase(
          margin: EdgeInsets.symmetric(vertical: 5),
          label: xclMenuItem.label,
          label_Color: xclMenuItem.label_Color,
          backGroundColor: xclMenuItem.color_BTN,
          icon: xclMenuItem.icon_BTN,
          icon_Widget: xclMenuItem.image_Icon_BTN != null ? Image.memory(xclMenuItem.image_Icon_BTN!) : null,
          label_Style: XStyles.xStyTextForLargeTitle(xclMenuItem.label_Color),
          width: width_menuItems ?? 250,
          height: height_menuItems ?? 50,
          onPressed: () {
            //xclMenuItem.onPressed
            if (xclMenuItem.onPressed != null) {
              xclMenuItem.onPressed!(xclMenuItem);
            }
            //onPressed_MenuItem
            else if (onPressed_MenuItem != null) {
              onPressed_MenuItem!(xclMenuItem);
            }
            tabLink();
          },
        );
      }).toList(),
    );
  }

  @override
  Widget build(BuildContext context) {
    return Drawer(
        child: Container(
            color: menu_BackGroundColor ?? Colors.white,
            child: Column(
              children: [
                Expanded(
                    flex: logOut_Visible != false ? 1 : 2,
                    child: SingleChildScrollView(
                        child: Column(children: <Widget>[
                      Container(
                          padding: EdgeInsets.all(15),
                          child: Column(children: <Widget>[
                            GestureDetector(
                              onTap: () {
                                onPressed_PinnedBTN != null ? onPressed_PinnedBTN!() : null;
                              },
                              child: Row(children: [
                                title != ""
                                    ? Expanded(
                                        child: Container(
                                            color: Colors.transparent,
                                            alignment: Alignment.centerLeft,
                                            margin: EdgeInsets.only(left: 10),
                                            child: Text(
                                              title!.toUpperCase(),
                                              style: title_Style ?? XStyles.xStyleText(fontSize: 12, colorText: XColors.backgroundDark, letterSpacing: 1.5),
                                            )))
                                    : Container(),
                                XBtnbase(
                                    icon: pinned_Value ? Icons.arrow_back_ios_new_rounded : Icons.arrow_forward_ios_rounded,
                                    icon_Color: XColors.backgroundLight,
                                    width: 40,
                                    height: 40,
                                    onPressed: () {
                                      onPressed_PinnedBTN != null ? onPressed_PinnedBTN!() : null;
                                    })
                              ]),
                            ),
                            Container(alignment: alignment ?? Alignment.center, child: Column(children: menuGroups.map((xclMenu) => xBuilder_XMenu(xclMenu)).toList())),
                          ])),
                      SizedBox(height: 15)
                    ]))),
                Visibility(
                  visible: logOut_Visible ?? true,
                  child: Expanded(
                    flex: 1,
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.end,
                      children: <Widget>[
                        Container(
                            color: logOut_BackGroundColor ?? Colors.grey,
                            child: ListTile(
                              title: logOut_Text ?? Text('Logout', style: XStyles.xStyleText(fontSize: 17, colorText: Colors.black), textAlign: TextAlign.left),
                              trailing: logOut_Icon ?? Icon(Icons.power_settings_new, color: Colors.red),
                              onTap: logOut_OnTap,
                            )),
                        SizedBox(height: MediaQuery.of(context).padding.bottom)
                      ],
                    ),
                  ),
                ),
              ],
            )));
  }
}

class XMenuGroup {
  String key;
  int? idx;
  String? label;
  List<XMenuItem> items = List<XMenuItem>.empty(growable: true);
  Color? label_Color;
  Color? color_BTN;
  IconData? icon_BTN;
  Uint8List? image_Icon_BTN;
  bool expanded = true;
  XMenuGroup(
    this.key, {
    this.label,
    this.idx,
    this.label_Color,
    this.color_BTN,
    this.icon_BTN,
    this.image_Icon_BTN,
    expanded,
    required this.items,
  });
  addMenuItem(XMenuItem item) {
    this.items.add(item);
  }
}

class XMenuItem {
  String key;
  int? idx;
  String? label;
  Color? label_Color;
  Color? color_BTN;
  IconData? icon_BTN;
  Uint8List? image_Icon_BTN;
  XMenuGroup? parent;

  Function(XMenuItem)? onPressed;

  ///uso futuro
  bool active = true;

  XMenuItem(
    this.key, {
    this.label,
    this.idx,
    this.label_Color,
    this.color_BTN,
    this.onPressed,
    this.icon_BTN,
    this.image_Icon_BTN,
    this.parent,
  });
}
